Imports System.IO
Imports System.IO.File
Imports System.Net

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim txt As String = Application.StartupPath
        If txt.EndsWith("\bin\Debug") Then txt = txt.Substring(0, txt.LastIndexOf("\bin\Debug"))
        txtLocalFile.Text = txt & "\test_local.txt"
        txtRemoteFile.Text = txt & "\test_remote.txt"
    End Sub

    ' Upload the local file to the remote file.
    Private Sub btnUpload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpload.Click
        FtpFile(txtLocalFile.Text, txtRemoteFile.Text, _
            txtUserName.Text, txtPassword.Text)
        Beep()
    End Sub

    ' Download the remote file to the local file.
    Private Sub btnDownload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDownload.Click
        FtpFile(txtRemoteFile.Text, txtLocalFile.Text, _
            txtUserName.Text, txtPassword.Text)
        Beep()
    End Sub

    ' Use FTP to transfer a file.
    Private Sub FtpFile(ByVal from_uri As String, ByVal to_uri As String, ByVal user_name As String, ByVal password As String)
        ' Open a FileStream to hold the new file.
        Dim fs_to As New FileStream( _
            to_uri, FileMode.Create)

        ' Connect to the FTP server.
        Dim request As FileWebRequest = _
            FtpWebRequest.Create(from_uri)

        ' Fill in the user name and password.
        request.Method = WebRequestMethods.Ftp.DownloadFile
        request.Credentials = New NetworkCredential( _
            user_name, password)

        ' Get the response and response stream.
        Dim response As WebResponse = request.GetResponse
        Dim response_stream As Stream = response.GetResponseStream

        ' Read the result file.
        Dim buffer(1024) As Byte
        Dim total_bytes As Long = 0
        Dim bytes_read As Integer = _
            response_stream.Read(buffer, 0, buffer.Length)
        While bytes_read > 0
            total_bytes += bytes_read
            fs_to.Write(buffer, 0, bytes_read)
            bytes_read = response_stream.Read(buffer, 0, 1024)
        End While

        ' Close the streams.
        fs_to.Close()
        response_stream.Close()

        Debug.WriteLine("FtpFile transfered " & _
            total_bytes.ToString() & " bytes")
    End Sub
End Class
